#include <stdlib.h>
#include <iostream.h>
#include <Instrument.h>
#include <ugens.h>
#include <Ougens.h>
#include "SIMPLESYNC.h"
#include <rt.h>

SIMPLESYNC::SIMPLESYNC() : Instrument()
{
}

int SIMPLESYNC::init(float p[], int n_args)
{
// initialization code goes here.
	// p0 = start, p[1] = duration, p[2] = frequency, p[3] = amp;
	// p[4] = sync frequency lo, p[5] = sync frequency hi

	nsamps = rtsetoutput(p[0], p[1], this);

	theOscil = new Ooscili(p[2], 1); // makegen 1 is the waveform

	srpointlo = (1.0/p[4]) * SR;
	srpointhi = (1.0/p[5]) * SR;
	sample_count = 0;

	theSync = new Ooscili(1.0/p[1], 2); // makegen 2 is the sync tracking
						// function

	amp = p[3];

	return(nsamps);
}

int SIMPLESYNC::run()
{
	int i;
	float out[2];
	int srpoint;
	
	Instrument::run();


	for (i = 0; i < chunksamps; i++) {
		out[0] = theOscil->next() * amp;
		out[1] = out[0];

		rtaddout(out);

		cursamp++;

		// we change the interrupt point ("srpoint") according
		// to the envelope (0-1) from the "theSync" oscil object
		sample_count++;
		srpoint = theSync->next() * (srpointhi-srpointlo) + srpointlo;
		if (sample_count > srpoint) // at this point we reset the oscil
		{
			theOscil->setphase(0.0);
			sample_count = 0;
		}
	}
	return i;
}

Instrument*
makeSIMPLESYNC()
{
	SIMPLESYNC *inst;
	inst = new SIMPLESYNC();
	inst->set_bus_config("SIMPLESYNC");
	return inst;
}

void
rtprofile()
{
	RT_INTRO("SIMPLESYNC",makeSIMPLESYNC);
}

